(PackageInfo named: 'acceptit-Libraries') preamble: '"below, add code to be run before the loading of this package"
ACLibraryCompiler provisionLibrary: ''ACAlbatrossLibrary''.'!
SystemOrganization addCategory: #'acceptit-Libraries'!

Object subclass: #ACAlbatrossLibrary
	instanceVariableNames: 'scenario browser testComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Libraries'!

ACAlbatrossLibrary class
	instanceVariableNames: 'browser'!

ACAlbatrossLibrary class
	instanceVariableNames: 'browser'!

!ACAlbatrossLibrary class methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 07:18'!
compilerClass

	^ACLibraryCompiler! !

!ACAlbatrossLibrary class methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 11:25'!
newForScenario: aUserStoryObjectBeeingAScenario

	^ self basicNew
		scenario: aUserStoryObjectBeeingAScenario;
		initialize! !

!ACAlbatrossLibrary class methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 12:16'!
parserClass

	^ ACSDParser! !

!ACAlbatrossLibrary class methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 18:17'!
shoutParserClass

	^ ACSHParserForLibrary! !

!ACAlbatrossLibrary methodsFor: 'accessing' stamp: 'topa 7/14/2010 15:28'!
browser

	^ browser! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:39'!
buildDefaultConfiguration: aDictionary

	aDictionary 
		at: #albatrossSubjectApplication
			put: WAApplication new;
		at: #albatrossPort
			put: 8080! !

!ACAlbatrossLibrary methodsFor: 'browsing' stamp: 'fg 7/11/2010 11:36'!
click: aButtonLabel
	
	self browser click: aButtonLabel.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 13:38'!
createTestComponent
	"See comment of #subjectApplication"
	
	^ (self subjectApplication configuration at: #rootClass) new! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:29'!
delay
	
	^ 0.5! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/11/2010 11:30'!
enter: aString for: aLabel
	
	self browser enter: aString for: aLabel.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 13:38'!
getTestComponent
	"I return the root component of the subject application"
	
	^ testComponent ifNil: [
		testComponent := self createTestComponent ]! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 11:26'!
scenario

	^scenario! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 11:26'!
scenario: anObject

	scenario := anObject! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:42'!
setUp
	| handler |	
	
	handler := ARequestHandler default reset; yourself.
	self wrapper port: (self scenario configuration at: #albatrossPort).
	self wrapper initializeWith: self subjectApplication for: self.
	
	browser := handler browser
		applicationUrl: self wrapper applicationUrl 
		driverUrl: self wrapper driverUrl.
	
	browser timeout: self timeout .
	browser responseDelay: self delay.
	browser open.
	browser timeout: self timeout.
	browser receiveOrTimeout.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 11:57'!
subjectApplication

	^ self scenario configuration at: #albatrossSubjectApplication
! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:46'!
tearDown

	self browser end.
	self wrapper port: nil.! !

!ACAlbatrossLibrary methodsFor: 'browsing' stamp: 'fg 7/11/2010 11:48'!
textExists: aString

	^self browser textExists: aString.! !

!ACAlbatrossLibrary methodsFor: 'browsing' stamp: 'topa 11/2/2010 18:51'!
(then) see :aString

	self scenario should: [
		self browser textExists: aString withoutQuoting]! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'db 7/22/2010 03:59'!
timeout
	^5! !

!ACAlbatrossLibrary methodsFor: 'browsing' stamp: 'topa 9/23/2010 13:00'!
(when) click on :aButtonLabel
	
	self browser click: aButtonLabel withoutQuoting.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 9/23/2010 13:00'!
(when) enter :aString for :aLabel
	
	self browser enter: aString withoutQuoting for: aLabel withoutQuoting.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:26'!
wrapper

	^ AComponentWrapper! !
